create or replace package dynamic_cursor
as

   type associative_row is table of varchar2(4000) index by varchar2(30);
   
   empty_row  associative_row;

   $if dbms_db_version.version > 10 $then
   procedure open(p_ref_cursor in out sys_refcursor);
   $end
   
   procedure open(p_sql varchar2);
   
   function fetch_row(p_row in out associative_row)
   return boolean;

   procedure close;
   
   procedure bind_variable(p_name varchar2, p_value varchar2);
   
   procedure bind_variable(p_name varchar2, p_value number);

   procedure bind_variable(p_name varchar2, p_value date);
   
   function string_variable(p_name varchar2)
   return varchar2
   deterministic;

   function number_variable(p_name varchar2)
   return number
   deterministic;

   function date_variable(p_name varchar2)
   return date
   deterministic;

   function get_column_desc
   return dbms_sql.desc_tab;
   /* for each column contains:
      col_type            BINARY_INTEGER := 0,
      col_max_len         BINARY_INTEGER := 0,
      col_name            VARCHAR2(32)   := '',
      col_name_len        BINARY_INTEGER := 0,
      col_schema_name     VARCHAR2(32)   := '',
      col_schema_name_len BINARY_INTEGER := 0,
      col_precision       BINARY_INTEGER := 0,
      col_scale           BINARY_INTEGER := 0,
      col_charsetid       BINARY_INTEGER := 0,
      col_charsetform     BINARY_INTEGER := 0,
      col_null_ok         BOOLEAN        := TRUE);
    */

end;

